/*-
 * Copyright 2020 Hochschule für Technik Stuttgart
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package de.hft.stuttgart.quality;

import java.util.Collections;
import java.util.List;

import org.citygml4j.core.visitor.ADEWalker;
import org.citygml4j.xml.ade.CityGMLADE;
import org.citygml4j.xml.module.ade.ADEModule;


public class QualityADEContext implements CityGMLADE {
	
	private final List<ADEModule> modules = Collections.singletonList(QualityADEModule.V0_1_4);

	@Override
	public List<ADEModule> getADEModules() {
		return modules;
	}
	
	@Override
	public ADEWalker getADEWalker() {
		return new QualityADEWalker();
	}

}
