package de.hft.stuttgart.quality.adapter.types;

import de.hft.stuttgart.quality.model.enums.TopLevelFeatureType;
import de.hft.stuttgart.quality.model.types.Checking;

import de.hft.stuttgart.quality.QualityADEModule;

import org.xmlobjects.annotation.XMLElement;
import org.xmlobjects.builder.ObjectBuildException;
import org.xmlobjects.builder.ObjectBuilder;
import org.xmlobjects.serializer.ObjectSerializeException;
import org.xmlobjects.serializer.ObjectSerializer;
import org.xmlobjects.stream.XMLReadException;
import org.xmlobjects.stream.XMLReader;
import org.xmlobjects.stream.XMLWriteException;
import org.xmlobjects.stream.XMLWriter;
import org.xmlobjects.xml.Attributes;
import org.xmlobjects.xml.Element;
import org.xmlobjects.xml.Namespaces;

import javax.xml.namespace.QName;

@XMLElement(name = "Checking", namespaceURI = QualityADEModule.NAMESPACE_URI)
public class CheckingAdapter implements ObjectBuilder<Checking>, ObjectSerializer<Checking> {

	@Override
	public Checking createObject(QName name, Object parent) throws ObjectBuildException {
		return new Checking();
	}

	@Override
	public void buildChildObject(Checking object, QName name, Attributes attributes, XMLReader reader)
			throws ObjectBuildException, XMLReadException {
		if (!QualityADEModule.NAMESPACE_URI.equals(name.getNamespaceURI())) {
			return;
		}
		switch (name.getLocalPart()) {
		case "featureType" -> reader.getTextContent()
				.ifPresent(s -> object.setFeatureType(TopLevelFeatureType.valueOf(s)));
		default -> throw new IllegalStateException("Cannot handle name " + name + " when building Checking element");
		}
	}

	@Override
	public Element createElement(Checking object, Namespaces namespaces) throws ObjectSerializeException {
		return Element.of(QualityADEModule.NAMESPACE_URI, "Checking");
	}

	@Override
	public void writeChildElements(Checking object, Namespaces namespaces, XMLWriter writer)
			throws ObjectSerializeException, XMLWriteException {
		if (object.getFeatureType() != null) {
			writer.writeElement(Element.of(QualityADEModule.NAMESPACE_URI, "featureType")
					.addTextContent(object.getFeatureType().toString()));
		}
	}
}
