package de.hft.stuttgart.quality.adapter.types;

import de.hft.stuttgart.quality.model.types.FeatureStatistics;

import de.hft.stuttgart.quality.QualityADEModule;

import org.xmlobjects.annotation.XMLElement;
import org.xmlobjects.builder.ObjectBuildException;
import org.xmlobjects.builder.ObjectBuilder;
import org.xmlobjects.serializer.ObjectSerializeException;
import org.xmlobjects.serializer.ObjectSerializer;
import org.xmlobjects.stream.XMLReadException;
import org.xmlobjects.stream.XMLReader;
import org.xmlobjects.stream.XMLWriteException;
import org.xmlobjects.stream.XMLWriter;
import org.xmlobjects.xml.Attributes;
import org.xmlobjects.xml.Element;
import org.xmlobjects.xml.Namespaces;

import javax.xml.namespace.QName;

@XMLElement(name = "FeatureStatistics", namespaceURI = QualityADEModule.NAMESPACE_URI)
public class FeatureStatisticsAdapter implements ObjectBuilder<FeatureStatistics>, ObjectSerializer<FeatureStatistics> {

	@Override
	public FeatureStatistics createObject(QName name, Object parent) throws ObjectBuildException {
		return new FeatureStatistics();
	}

	@Override
	public void buildChildObject(FeatureStatistics object, QName name, Attributes attributes, XMLReader reader)
			throws ObjectBuildException, XMLReadException {
		if (!QualityADEModule.NAMESPACE_URI.equals(name.getNamespaceURI())) {
			return;
		}
		switch (name.getLocalPart()) {
		case "numChecked" -> reader.getTextContent().ifPresent(s -> object.setNumChecked(Integer.parseInt(s)));
		case "numErrors" -> reader.getTextContent().ifPresent(s -> object.setNumErrors(Integer.parseInt(s)));
		default -> throw new IllegalStateException(
				"Cannot handle name " + name + " when building FeatureStatistics element");
		}
	}
	
	@Override
	public Element createElement(FeatureStatistics object, Namespaces namespaces) throws ObjectSerializeException {
		return Element.of(QualityADEModule.NAMESPACE_URI, "FeatureStatistics");
	}

	@Override
	public void writeChildElements(FeatureStatistics object, Namespaces namespaces, XMLWriter writer)
			throws ObjectSerializeException, XMLWriteException {
		writer.writeElement(Element.of(QualityADEModule.NAMESPACE_URI, "numChecked")
				.addTextContent(Integer.toString(object.getNumChecked())));
		writer.writeElement(Element.of(QualityADEModule.NAMESPACE_URI, "numErrors")
				.addTextContent(Integer.toString(object.getNumErrors())));
	}
}
