package de.hft.stuttgart.quality.adapter.types;

import javax.xml.namespace.QName;

import org.xmlobjects.annotation.XMLElement;
import org.xmlobjects.builder.ObjectBuildException;
import org.xmlobjects.builder.ObjectBuilder;
import org.xmlobjects.serializer.ObjectSerializeException;
import org.xmlobjects.serializer.ObjectSerializer;
import org.xmlobjects.stream.XMLReadException;
import org.xmlobjects.stream.XMLReader;
import org.xmlobjects.stream.XMLWriteException;
import org.xmlobjects.stream.XMLWriter;
import org.xmlobjects.xml.Attributes;
import org.xmlobjects.xml.Element;
import org.xmlobjects.xml.Namespaces;

import de.hft.stuttgart.quality.QualityADEModule;
import de.hft.stuttgart.quality.adapter.properties.CheckingPropertyAdapter;
import de.hft.stuttgart.quality.model.properties.CheckingProperty;
import de.hft.stuttgart.quality.model.types.Filter;

@XMLElement(name = "Filter", namespaceURI = QualityADEModule.NAMESPACE_URI)
public class FilterAdapter implements ObjectBuilder<Filter>, ObjectSerializer<Filter> {

	@Override
	public Filter createObject(QName name, Object parent) throws ObjectBuildException {
		return new Filter();
	}

	@Override
	public void buildChildObject(Filter object, QName name, Attributes attributes, XMLReader reader)
			throws ObjectBuildException, XMLReadException {
		if (!QualityADEModule.NAMESPACE_URI.equals(name.getNamespaceURI())) {
			return;
		}
		switch (name.getLocalPart()) {
		case "checking" -> object.getChecking().add(reader.getObjectUsingBuilder(CheckingPropertyAdapter.class));
		default -> throw new IllegalStateException("Cannot handle name " + name + " when building Filter element");
		}
	}

	@Override
	public Element createElement(Filter object, Namespaces namespaces) throws ObjectSerializeException {
		return Element.of(QualityADEModule.NAMESPACE_URI, "Filter");
	}

	@Override
	public void writeChildElements(Filter object, Namespaces namespaces, XMLWriter writer)
			throws ObjectSerializeException, XMLWriteException {
		for (CheckingProperty checkProp : object.getChecking()) {
			writer.writeElementUsingSerializer(Element.of(QualityADEModule.NAMESPACE_URI, "checking"), checkProp,
					CheckingPropertyAdapter.class, namespaces);
		}
	}
}
