package de.hft.stuttgart.quality.adapter.types;

import javax.xml.namespace.QName;

import org.xmlobjects.annotation.XMLElement;
import org.xmlobjects.builder.ObjectBuildException;
import org.xmlobjects.serializer.ObjectSerializeException;
import org.xmlobjects.stream.XMLReadException;
import org.xmlobjects.stream.XMLReader;
import org.xmlobjects.stream.XMLWriteException;
import org.xmlobjects.stream.XMLWriter;
import org.xmlobjects.xml.Attributes;
import org.xmlobjects.xml.Element;
import org.xmlobjects.xml.Namespaces;

import de.hft.stuttgart.quality.QualityADEModule;
import de.hft.stuttgart.quality.model.types.HoleOutsideError;

@XMLElement(name = "GE_P_HOLE_OUTSIDE", namespaceURI = QualityADEModule.NAMESPACE_URI)
public class HoleOutsideErrorAdapter extends AbstractPolygonErrorAdapter<HoleOutsideError> {

	@Override
	public HoleOutsideError createObject(QName name, Object parent) throws ObjectBuildException {
		return new HoleOutsideError();
	}

	@Override
	public void buildChildObject(HoleOutsideError object, QName name, Attributes attributes, XMLReader reader)
			throws ObjectBuildException, XMLReadException {
		if (!QualityADEModule.NAMESPACE_URI.equals(name.getNamespaceURI())) {
			return;
		}
		switch (name.getLocalPart()) {
		case "linearRingId" -> reader.getTextContent().ifPresent(object::setLinearRingId);
		default -> super.buildChildObject(object, name, attributes, reader);
		}
	}
	
	@Override
	public Element createElement(HoleOutsideError object, Namespaces namespaces) throws ObjectSerializeException {
		return Element.of(QualityADEModule.NAMESPACE_URI, "GE_P_HOLE_OUTSIDE");
	}

	@Override
	public void writeChildElements(HoleOutsideError object, Namespaces namespaces, XMLWriter writer)
			throws ObjectSerializeException, XMLWriteException {
		super.writeChildElements(object, namespaces, writer);
		
		if (object.getLinearRingId() != null) {
			writer.writeElement(Element.of(QualityADEModule.NAMESPACE_URI, "linearRingId")
					.addTextContent(object.getLinearRingId()));
		}
	}
}
