package de.hft.stuttgart.quality.adapter.types;

import de.hft.stuttgart.quality.model.types.Parameter;

import de.hft.stuttgart.quality.QualityADEModule;

import org.xmlobjects.annotation.XMLElement;
import org.xmlobjects.builder.ObjectBuildException;
import org.xmlobjects.builder.ObjectBuilder;
import org.xmlobjects.serializer.ObjectSerializeException;
import org.xmlobjects.serializer.ObjectSerializer;
import org.xmlobjects.stream.XMLReadException;
import org.xmlobjects.stream.XMLReader;
import org.xmlobjects.stream.XMLWriteException;
import org.xmlobjects.stream.XMLWriter;
import org.xmlobjects.xml.Attributes;
import org.xmlobjects.xml.Element;
import org.xmlobjects.xml.Namespaces;

import javax.xml.namespace.QName;

@XMLElement(name = "Parameter", namespaceURI = QualityADEModule.NAMESPACE_URI)
public class ParameterAdapter implements ObjectBuilder<Parameter>, ObjectSerializer<Parameter> {

    @Override
    public Parameter createObject(QName name, Object parent) throws ObjectBuildException {
        return new Parameter();
    }

    @Override
    public void buildChildObject(Parameter object, QName name, Attributes attributes, XMLReader reader) throws ObjectBuildException, XMLReadException {
        if (!QualityADEModule.NAMESPACE_URI.equals(name.getNamespaceURI())) {
            return;
        }
        switch (name.getLocalPart()) {
            case "name" -> reader.getTextContent().ifPresent(object::setName);
            case "uom" -> reader.getTextContent().ifPresent(object::setUom);
            case "value" -> reader.getTextContent().ifPresent(object::setValue);
        default -> throw new IllegalStateException("Cannot handle name " + name + " when building Parameter element");
        }
    }
    
    @Override
    public Element createElement(Parameter object, Namespaces namespaces) throws ObjectSerializeException {
    	return Element.of(QualityADEModule.NAMESPACE_URI, "Parameter");
    }

    @Override
    public void writeChildElements(Parameter object, Namespaces namespaces, XMLWriter writer) throws ObjectSerializeException, XMLWriteException {
        if (object.getName() != null) {
            writer.writeElement(Element.of(QualityADEModule.NAMESPACE_URI, "name").addTextContent(object.getName()));
        }
        if (object.getUom() != null) {
            writer.writeElement(Element.of(QualityADEModule.NAMESPACE_URI, "uom").addTextContent(object.getUom()));
        }
        if (object.getValue() != null) {
            writer.writeElement(Element.of(QualityADEModule.NAMESPACE_URI, "value").addTextContent(object.getValue()));
        }
    }
}
