package de.hft.stuttgart.quality.adapter.types;

import de.hft.stuttgart.quality.model.types.PolygonIdList;

import de.hft.stuttgart.quality.QualityADEModule;

import org.xmlobjects.annotation.XMLElement;
import org.xmlobjects.builder.ObjectBuildException;
import org.xmlobjects.builder.ObjectBuilder;
import org.xmlobjects.serializer.ObjectSerializeException;
import org.xmlobjects.serializer.ObjectSerializer;
import org.xmlobjects.stream.XMLReadException;
import org.xmlobjects.stream.XMLReader;
import org.xmlobjects.stream.XMLWriteException;
import org.xmlobjects.stream.XMLWriter;
import org.xmlobjects.xml.Attributes;
import org.xmlobjects.xml.Element;
import org.xmlobjects.xml.Namespaces;

import javax.xml.namespace.QName;

@XMLElement(name = "PolygonIdList", namespaceURI = QualityADEModule.NAMESPACE_URI)
public class PolygonIdListAdapter implements ObjectBuilder<PolygonIdList>, ObjectSerializer<PolygonIdList> {

	@Override
	public PolygonIdList createObject(QName name, Object parent) throws ObjectBuildException {
		return new PolygonIdList();
	}

	@Override
	public void buildChildObject(PolygonIdList object, QName name, Attributes attributes, XMLReader reader)
			throws ObjectBuildException, XMLReadException {
		if (!QualityADEModule.NAMESPACE_URI.equals(name.getNamespaceURI())) {
			return;
		}
		switch (name.getLocalPart()) {
		case "polygonId" -> object.getPolygonIds().add(reader.getTextContent().get());
		default -> throw new IllegalStateException(
				"Cannot handle name " + name + " when building PolygonIdList element");
		}
	}
	
	@Override
	public Element createElement(PolygonIdList object, Namespaces namespaces) throws ObjectSerializeException {
		return Element.of(QualityADEModule.NAMESPACE_URI, "PolygonIdList");
	}

	@Override
	public void writeChildElements(PolygonIdList object, Namespaces namespaces, XMLWriter writer)
			throws ObjectSerializeException, XMLWriteException {
		for (String polygonId : object.getPolygonIds()) {
			writer.writeElement(Element.of(QualityADEModule.NAMESPACE_URI, "polygonId").addTextContent(polygonId));
		}
	}
}
