package de.hft.stuttgart.quality.adapter.types;

import javax.xml.namespace.QName;

import org.xmlobjects.annotation.XMLElement;
import org.xmlobjects.builder.ObjectBuildException;
import org.xmlobjects.serializer.ObjectSerializeException;
import org.xmlobjects.stream.XMLReadException;
import org.xmlobjects.stream.XMLReader;
import org.xmlobjects.stream.XMLWriteException;
import org.xmlobjects.stream.XMLWriter;
import org.xmlobjects.xml.Attributes;
import org.xmlobjects.xml.Element;
import org.xmlobjects.xml.Namespaces;

import de.hft.stuttgart.quality.QualityADEModule;
import de.hft.stuttgart.quality.model.types.SolidSelfIntersectionError;

@XMLElement(name = "GE_S_SELF_INTERSECTION", namespaceURI = QualityADEModule.NAMESPACE_URI)
public class SolidSelfIntersectionErrorAdapter extends AbstractSolidErrorAdapter<SolidSelfIntersectionError> {

	@Override
	public SolidSelfIntersectionError createObject(QName name, Object parent) throws ObjectBuildException {
		return new SolidSelfIntersectionError();
	}

	@Override
	public void buildChildObject(SolidSelfIntersectionError object, QName name, Attributes attributes, XMLReader reader)
			throws ObjectBuildException, XMLReadException {
		if (!QualityADEModule.NAMESPACE_URI.equals(name.getNamespaceURI())) {
			return;
		}
		switch (name.getLocalPart()) {
		case "polygonId1" -> reader.getTextContent().ifPresent(object::setPolygonId1);
		case "polygonId2" -> reader.getTextContent().ifPresent(object::setPolygonId2);

		default -> super.buildChildObject(object, name, attributes, reader);
		}
	}

	@Override
	public Element createElement(SolidSelfIntersectionError object, Namespaces namespaces)
			throws ObjectSerializeException {
		return Element.of(QualityADEModule.NAMESPACE_URI, "GE_S_SELF_INTERSECTION");
	}

	@Override
	public void writeChildElements(SolidSelfIntersectionError object, Namespaces namespaces, XMLWriter writer)
			throws ObjectSerializeException, XMLWriteException {
		super.writeChildElements(object, namespaces, writer);
		if (object.getPolygonId1() != null) {
			writer.writeElement(
					Element.of(QualityADEModule.NAMESPACE_URI, "polygonId1").addTextContent(object.getPolygonId1()));
		}
		if (object.getPolygonId2() != null) {
			writer.writeElement(
					Element.of(QualityADEModule.NAMESPACE_URI, "polygonId2").addTextContent(object.getPolygonId2()));
		}
	}
}
