/*-
 * Copyright 2022 Hochschule für Technik Stuttgart
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package de.hft.stuttgart.quality.model.properties;

import java.io.Serial;

import org.citygml4j.core.model.ade.ADEObject;
import org.xmlobjects.gml.model.base.AbstractInlineProperty;

import de.hft.stuttgart.quality.model.types.Requirement;

public class RequirementProperty extends AbstractInlineProperty<Requirement> implements ADEObject {

    @Serial
    private static final long serialVersionUID = 1084132873819307011L;

    public RequirementProperty() {
        super();
    }

    public RequirementProperty(Requirement r) {
        super(r);
    }

    @Override
    public Class<Requirement> getTargetType() {
        return Requirement.class;
    }

}
