/*-
 * Copyright 2022 Hochschule für Technik Stuttgart
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package de.hft.stuttgart.quality.model.types;

import java.io.Serial;

import org.xmlobjects.gml.model.geometry.DirectPosition;

import de.hft.stuttgart.quality.model.walker.ValidationErrorVisitor;

public class ConsecutivePointsSameError extends AbstractRingError {

	@Serial
	private static final long serialVersionUID = 960107689338308020L;

	private DirectPosition vertex1;
	private DirectPosition vertex2;

	public DirectPosition getVertex1() {
		return vertex1;
	}

	public void setVertex1(DirectPosition vertex1) {
		this.vertex1 = asChild(vertex1);
	}

	public DirectPosition getVertex2() {
		return vertex2;
	}

	public void setVertex2(DirectPosition vertex2) {
		this.vertex2 = asChild(vertex2);
	}
	
	@Override
	public void accept(ValidationErrorVisitor visitor) {
		super.accept(visitor);
		visitor.visit(this);
	}

	@Override
	public String toString() {
		return "ConsecutivePointsSameError [vertex1=" + vertex1 + ", vertex2=" + vertex2 + "]";
	}

}
