/*-
 * Copyright 2022 Hochschule für Technik Stuttgart
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package de.hft.stuttgart.quality.model.types;

import java.io.Serial;

import org.citygml4j.core.model.ade.ADEObject;
import org.xmlobjects.gml.model.GMLObject;
import org.xmlobjects.gml.model.geometry.DirectPosition;

public class Edge extends GMLObject implements ADEObject {

	@Serial
	private static final long serialVersionUID = 8021062845313752146L;

	private DirectPosition from;
	private DirectPosition to;

	public DirectPosition getFrom() {
		return from;
	}

	public void setFrom(DirectPosition from) {
		this.from = asChild(from);
	}

	public DirectPosition getTo() {
		return to;
	}

	public void setTo(DirectPosition to) {
		this.to = asChild(to);
	}

	@Override
	public String toString() {
		return "Edge [from=" + from + ", to=" + to + "]";
	}

}
