/*-
 * Copyright 2022 Hochschule für Technik Stuttgart
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package de.hft.stuttgart.quality.model.types;

import java.io.Serial;
import java.util.List;

import org.citygml4j.core.model.ade.ADEObject;
import org.xmlobjects.gml.model.GMLObject;
import org.xmlobjects.model.ChildList;

import de.hft.stuttgart.quality.model.properties.EdgeProperty;

public class EdgeList extends GMLObject implements ADEObject {

    @Serial
    private static final long serialVersionUID = 5900643456940461301L;
    
    private List<EdgeProperty> edges;

	public List<EdgeProperty> getEdges() {
		if (edges == null) {
			edges = new ChildList<>(this);
		}
		return edges;
	}

	public void setEdges(List<EdgeProperty> edges) {
		this.edges = asChild(edges);
	}

}
