/*-
 * Copyright 2022 Hochschule für Technik Stuttgart
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package de.hft.stuttgart.quality.model.types;

import java.io.Serial;
import java.time.ZonedDateTime;

import org.citygml4j.core.model.ade.ADEObject;
import org.citygml4j.core.model.core.AbstractFeature;

import de.hft.stuttgart.quality.model.properties.StatisticsProperty;
import de.hft.stuttgart.quality.model.properties.ValidationPlanProperty;

public class Validation extends AbstractFeature implements ADEObject {

	@Serial
	private static final long serialVersionUID = 7821104529898548535L;

	private ZonedDateTime validationDate;
	private String validationSoftware;
	private StatisticsProperty statistics;
	private ValidationPlanProperty validationPlan;

	public ZonedDateTime getValidationDate() {
		return validationDate;
	}

	public void setValidationDate(ZonedDateTime validationDate) {
		this.validationDate = validationDate;
	}

	public String getValidationSoftware() {
		return validationSoftware;
	}

	public void setValidationSoftware(String validationSoftware) {
		this.validationSoftware = validationSoftware;
	}

	public StatisticsProperty getStatistics() {
		return statistics;
	}

	public void setStatistics(StatisticsProperty statistics) {
		this.statistics = asChild(statistics);
	}

	public ValidationPlanProperty getValidationPlan() {
		return validationPlan;
	}

	public void setValidationPlan(ValidationPlanProperty validationPlan) {
		this.validationPlan = asChild(validationPlan);
	}

}
